package com.mortals.xhx.module.matter.web;
import com.mortals.framework.common.IBaseEnum;
import com.mortals.framework.common.Rest;
import com.mortals.framework.common.code.YesNo;
import com.mortals.framework.exception.AppException;
import com.mortals.framework.model.OrderCol;
import com.mortals.framework.service.IUser;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.base.system.param.service.ParamService;
import com.mortals.xhx.common.code.MatterSourceEnum;
import com.mortals.xhx.common.key.ParamKey;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.ObjectUtils;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.bind.annotation.*;
import com.mortals.framework.model.Context;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.module.matter.model.MatterEntity;
import com.mortals.xhx.module.matter.service.MatterService;
import org.apache.commons.lang3.ArrayUtils;
import com.mortals.framework.util.StringUtils;

import java.util.*;
import java.util.stream.Collectors;
import com.alibaba.fastjson.JSONObject;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import static com.mortals.framework.ap.SysConstains.*;
/**
*
* 事项申请材料
*
* @author zxfei
* @date 2022-09-27
*/
@RestController
@RequestMapping("matter")
public class MatterController extends BaseCRUDJsonBodyMappingController<MatterService,MatterEntity,Long> {

    @Autowired
    private ParamService paramService;

    public MatterController(){
        super.setModuleDesc( "事项");
    }

    @Override
    protected void init(Map<String, Object> model, Context context) {
        this.addDict(model, "isRecommend", paramService.getParamBySecondOrganize("Matter","isRecommend"));
        this.addDict(model, "source", IBaseEnum.getEnumMap(MatterSourceEnum.class));
        super.init(model, context);
    }

    @Override
    protected void doListBefore(MatterEntity query, Map<String, Object> model, Context context) throws AppException {
        List<OrderCol> orderColList = new ArrayList<>();
        orderColList.add(new OrderCol("isRecommend",OrderCol.DESCENDING));
        query.setOrderColList(orderColList);
        super.doListBefore(query, model, context);
    }

    @Override
    protected int doListAfter(MatterEntity query, Map<String, Object> model, Context context) throws AppException {
        int recommendCount = paramService.getParamIntValue(ParamKey.MATTER_RECOMMEND_COUNT);
        model.put("recommendCount", recommendCount);
        return super.doListAfter(query, model, context);
    }

    @RequestMapping(value = {"createMatter"},method = {RequestMethod.POST, RequestMethod.GET})
    public String createMatter(Long[] ids,Long siteId) {
//    public String createMatter(Long[] ids) {
        Map<String, Object> model = new HashMap();
        int code = 1;
        String busiDesc = "站点事项转事项";

        try {
            Rest<String> rest = this.service.createMatterbBySheetMatter(ids, siteId, getContext());
            model.put("message_info", rest.getData());
            this.recordSysLog(this.request, rest.getData());
        } catch (Exception var7) {
            code = -1;
            this.doException(this.request, busiDesc, model, var7);
        }

        JSONObject ret = new JSONObject();
        ret.put("code", Integer.valueOf(code));
        ret.put("data", model);
        return ret.toJSONString();
    }


    @RequestMapping(value = {"recommend"},method = {RequestMethod.POST, RequestMethod.GET})
    public String recommend(Long id) {
        Context context = this.getContext();
        Map<String, Object> model = new HashMap();
        int code = 1;
        String busiDesc = "推荐or取消推荐" + this.getModuleDesc();
        try {
            this.service.recommend(id);
            model.put("message_info", this.getModuleDesc() + "推荐or取消推荐成功!");
            this.recordSysLog(this.request, busiDesc + " 【成功】 [id:" + id + "]");
        } catch (Exception var7) {
            code = -1;
            this.doException(this.request, busiDesc, model, var7);
        }

        JSONObject ret = new JSONObject();
        ret.put("code", Integer.valueOf(code));
        ret.put("msg", model.remove("message_info"));
        ret.put("data", model);
        return ret.toJSONString();
    }
}